<?php

/*********************************************************************

 新着アルバム表示プラグイン (2016/03/07)

  32877|http://32877.xii.jp

*********************************************************************/

//外部ファイル読み込み
require_once FREO_MAIN_DIR . 'freo/plugins/associate_plugin_album.php';
require_once FREO_MAIN_DIR . 'freo/plugins/security_plugin_album.php';
require_once FREO_MAIN_DIR . 'freo/plugins/filter_plugin_album.php';

/* メイン処理 */
function freo_display_album_recently()
{
	global $freo;

	if ($freo->config['plugin']['album_recently']['default_limit'] == 0) {
		return;
	}

	//検索条件設定
	$category_id = false;
		if ($freo->config['plugin']['album_recently']['category_id']) {
			$category_id = true;
		}

	if ($category_id == true){
		$condition = ' WHERE id IS NOT NULL AND category_id =:category_id';
	} else {
		$condition = ' WHERE id IS NOT NULL OR category_id =:category_id';
	}

	//アルバム取得
	$stmt = $freo->pdo->prepare('SELECT * FROM ' . FREO_DATABASE_PREFIX . 'plugin_albums ' . $condition . ' ORDER BY id DESC LIMIT :limit');
	$stmt->bindValue(':limit', intval($freo->config['plugin']['album_recently']['default_limit']), PDO::PARAM_INT);
	$stmt->bindvalue(':category_id', $freo->config['plugin']['album_recently']['category_id']);
	$flag = $stmt->execute();
	if (!$flag) {
		freo_error($stmt->errorInfo());
	}

	$plugin_albums = array();
	while ($data = $stmt->fetch(PDO::FETCH_ASSOC)) {
		$plugin_albums[$data['id']] = $data;
	}

	//アルバムID取得
	$plugin_album_keys = array_keys($plugin_albums);

	//アルバムタグ取得
	$plugin_album_tags = array();
	foreach ($plugin_album_keys as $plugin_album) {
		if (!$plugin_albums[$plugin_album]['tag']) {
			continue;
		}

		$plugin_album_tags[$plugin_album] = explode(',', $plugin_albums[$plugin_album]['tag']);
	}

	//表示順
	$sort = 0;
	if ($freo->config['plugin']['album']['album_file_sort'] = 'descend') {
		$sort = 1;
	}

	//ファイル取得
	$plugin_album_files = array();
	foreach ($plugin_album_keys as $plugin_album) {
		$file_dir = FREO_FILE_DIR . 'plugins/album_files/' . $plugin_album . '/';
		$thumbnail_dir = FREO_FILE_DIR . 'plugins/album_thumbnails/' . $plugin_album . '/';

		if (file_exists($file_dir)) {
			if ($dir = scandir($file_dir, $sort)) {
				foreach ($dir as $data) {
					if (is_file($file_dir . $data) and preg_match("/(\w+)\.\w+$/", $data, $matches)) {
						list($width, $height, $size) = freo_file($file_dir . $data);
						if (is_file($thumbnail_dir . $data) and preg_match("/(\w+)\.\w+$/", $data, $matches)) {
							list($thumbnailwidth, $thumbnailheight, $thumbnailsize) = freo_file($thumbnail_dir . $data);
							$thumbnail = array(
								'name'    => $data,
								'width'   => $thumbnailwidth,
								'height'  => $thumbnailheight,
								'size'    => $thumbnailsize
							);
						} else {
							$thumbnail = array();
						}
						$plugin_album_files[$plugin_album][$matches[1]] = array(
							'name'      => $data,
							'width'     => $width,
							'height'    => $height,
							'size'      => $size,
							'thumbnail' => $thumbnail
						);
					}
				}
			} else {
				freo_error('ファイル保存ディレクトリを開けません。');
			}
		}
	}
	

	//アルバム関連データ取得
	$plugin_album_associates = freo_associate_plugin_album('get', $plugin_album_keys);

	//アルバムフィルター取得
	$plugin_album_filters = freo_filter_plugin_album('user', $plugin_album_keys);

	foreach ($plugin_album_filters as $id => $filter) {
		if (!$filter) {
			continue;
		}

		$plugin_albums[$id]['title']     = str_replace('[$title]', $plugin_albums[$id]['title'], $freo->config['plugin']['album']['filter_title']);
		$plugin_albums[$id]['file']      = null;
		$plugin_album_files[$id]         = null;
		$plugin_albums[$id]['text']      = str_replace('[$text]', $plugin_albums[$id]['text'], $freo->config['plugin']['album']['filter_text']);
	}

	//アルバム保護データ取得
	$plugin_album_securities = freo_security_plugin_album('user', $plugin_album_keys);

	foreach ($plugin_album_securities as $id => $security) {
		if (!$security) {
			continue;
		}

		$plugin_albums[$id]['title']     = str_replace('[$title]', $plugin_albums[$id]['title'], $freo->config['plugin']['album']['restriction_title']);
		$plugin_albums[$id]['file']      = null;
		$plugin_album_files[$id]         = null;
		$plugin_albums[$id]['text']      = str_replace('[$text]', $plugin_albums[$id]['text'], $freo->config['plugin']['album']['restriction_text']);

	}

	//データ割当
	$freo->smarty->assign(array(
		'plugin_album_recentries'          => $plugin_albums,
		'plugin_album_recently_tags'       => $plugin_album_tags,
		'plugin_album_recently_files'      => $plugin_album_files
	));

	return;
}

?>
